]> git.saurik.com Git - bison.git/blob - bootstrap
4b6b012f78ace45f172000c743cc744a80fa7bb5
[bison.git] / bootstrap
1 #! /bin/sh
2
3 # Bootstrap this package from CVS.
4
5 # Copyright (C) 2003, 2004, 2005 Free Software Foundation, Inc.
6
7 # This program is free software; you can redistribute it and/or modify
8 # it under the terms of the GNU General Public License as published by
9 # the Free Software Foundation; either version 2, or (at your option)
10 # any later version.
11
12 # This program is distributed in the hope that it will be useful,
13 # but WITHOUT ANY WARRANTY; without even the implied warranty of
14 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
15 # GNU General Public License for more details.
16
17 # You should have received a copy of the GNU General Public License
18 # along with this program; if not, write to the Free Software
19 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
20 # 02110-1301, USA.
21
22 # Written by Paul Eggert.
23
24 package=bison
25
26 # Ensure file names are sorted consistently across platforms;
27 # e.g., m4/ulonglong_gl.m4 should follow m4/ulonglong.m4.
28 # Also, ensure diagnostics are in English, e.g., "wget --help" below.
29 LC_ALL=C
30 export LC_ALL
31
32 # Parse options.
33
34 for option
35 do
36 case $option in
37 --help)
38 echo "$0: usage: $0 [--gnulib-srcdir=DIR] [--cvs-user=USERNAME] [--skip-po]"
39 exit;;
40 --gnulib-srcdir=*)
41 GNULIB_SRCDIR=`expr "$option" : '--gnulib-srcdir=\(.*\)'`;;
42 --cvs-user=*)
43 CVS_USER=`expr "$option" : '--cvs-user=\(.*\)'`;;
44 --skip-po)
45 SKIP_PO=t;;
46 *)
47 echo >&2 "$0: $option: unknown option"
48 exit 1;;
49 esac
50 done
51
52 echo "$0: Bootstrapping CVS $package..."
53
54 build_cvs_prefix() {
55 CVS_PREFIX=:${1}:
56 if [ "${2}" != - ]; then
57 CVS_PREFIX=${CVS_PREFIX}${2}@
58 fi
59 }
60
61 # Get gnulib files.
62
63 case ${GNULIB_SRCDIR--} in
64 -)
65 if [ ! -d gnulib ]; then
66 echo "$0: getting gnulib files..."
67
68 trap exit 1 2 13 15
69 trap 'rm -fr gnulib; exit 1' 0
70
71 case ${CVS_AUTH-anoncvs} in
72 anoncvs)
73 CVS_PREFIX='anoncvs@';;
74 ssh)
75 CVS_PREFIX="$CVS_USER${CVS_USER+@}";;
76 *)
77 echo "$0: $CVS_AUTH: Unknown CVS access method" >&2
78 exit 1;;
79 esac
80
81 case $CVS_RSH in
82 '') export CVS_RSH=ssh;;
83 esac
84
85 cvs -z3 -q -d ${CVS_PREFIX}subversions.gnu.org:/cvsroot/gnulib co gnulib || exit
86
87 trap - 0
88 fi
89 GNULIB_SRCDIR=gnulib
90 esac
91
92 <$GNULIB_SRCDIR/gnulib-tool || exit
93
94 gnulib_modules='
95 alloca
96 argmatch
97 dirname
98 error
99 extensions
100 getopt
101 gettext
102 hard-locale
103 hash
104 malloc
105 mbswidth
106 obstack
107 quote
108 quotearg
109 stdbool
110 stdio-safer
111 stpcpy
112 unistd-safer
113 xalloc
114 xalloc-die
115 xstrndup
116 '
117
118 previous_gnulib_modules=
119 while [ "$gnulib_modules" != "$previous_gnulib_modules" ]; do
120 previous_gnulib_modules=$gnulib_modules
121 gnulib_modules=`
122 (echo "$gnulib_modules"
123 for gnulib_module in $gnulib_modules; do
124 $GNULIB_SRCDIR/gnulib-tool --extract-dependencies $gnulib_module
125 done) | sort -u
126 `
127 done
128
129 gnulib_files=`
130 (for gnulib_module in $gnulib_modules; do
131 $GNULIB_SRCDIR/gnulib-tool --extract-filelist $gnulib_module
132 done) | sort -u
133 `
134
135 gnulib_dirs=`echo "$gnulib_files" | sed 's,/[^/]*$,,' | sort -u`
136 mkdir -p $gnulib_dirs || exit
137
138 for gnulib_file in $gnulib_files; do
139 dest=$gnulib_file
140
141 case $gnulib_file in
142 m4/onceonly_2_57.m4) dest=m4/onceonly.m4;;
143 # These will be overwritten by autopoint, which still uses
144 # old jm_.* macro names, so we have to keep both copies.
145 # m4/gettext.m4 isn't mentioned here, since it's patched below.
146 m4/glibc21.m4 | m4/inttypes_h.m4 | m4/lib-ld.m4 | \
147 m4/lib-prefix.m4 | m4/po.m4 | m4/stdint_h.m4 | m4/uintmax_t.m4 | \
148 m4/ulonglong.m4)
149 dest=`expr $gnulib_file : '\(.*\).m4'`_gl.m4;;
150 esac
151
152 rm -f $dest &&
153 echo "$0: Copying file $GNULIB_SRCDIR/$gnulib_file" &&
154 cp -p $GNULIB_SRCDIR/$gnulib_file $dest || exit
155 done
156
157 echo "$0: patching m4/gettext.m4 so that AM_INTL_SUBDIR is empty ..."
158 sed '
159 /^AC_DEFUN(\[AM_INTL_SUBDIR],/,/^]/c\
160 AC_DEFUN([AM_INTL_SUBDIR], [])
161 ' m4/gettext.m4 >m4/gettext_gl.m4 || exit
162
163
164 # Get translations.
165
166 case $SKIP_PO in
167 '')
168 case `wget --help` in
169 *'--no-cache'*)
170 no_cache='--no-cache';;
171 *'--cache=on/off'*)
172 no_cache='--cache=off';;
173 *)
174 no_cache='';;
175 esac
176
177 echo "$0: getting translations into po (please ignore the robots.txt ERROR 404)..."
178 (cd po &&
179 rm -f dummy `ls | sed -n '/\.gmo$/p; /\.po/p'` &&
180 wget -nv -nd -r -l 1 -A .po $no_cache \
181 http://www.iro.umontreal.ca/translation/maint/$package/ &&
182 ls *.po | sed 's/\.po$//' >LINGUAS
183 ) || exit
184
185 case $package in
186 bison)
187 echo "$0: getting translations into po (please ignore the robots.txt ERROR 404)..."
188 (cd runtime-po &&
189 rm -f dummy `ls | sed -n '/\.gmo$/p; /\.po$/p'` &&
190 wget -nv -nd -r -l 1 -A .po $no_cache \
191 http://www.iro.umontreal.ca/translation/maint/$package-runtime/ &&
192
193 # For translations that have not yet been upgraded to the new
194 # runtime-po domain, prime the pump by extracting the relevant
195 # strings from the obsolete translations.
196 # This code can be removed once the bison-runtime domain
197 # has been translated by each team.
198 for po in ../po/*.po; do
199 test -f "$po" || continue
200 runpo=`basename $po`
201 test -f $runpo || {
202 msggrep -K \
203 -e 'memory exhausted' \
204 -e 'syntax error' \
205 $po 2>/dev/null |
206 sed '
207 s/^#~ //
208 /^msgid "syntax error; also memory exhausted"$/,/^$/d
209 /^$/,${ /^#/d; }
210 ' >$runpo-
211 if cmp -s $runpo- $runpo; then
212 rm $runpo-
213 else
214 mv $runpo- $runpo
215 fi
216 test -s $runpo || rm -f $runpo
217 } || exit
218 done &&
219
220 ls *.po | sed 's/\.po$//' >LINGUAS
221 ) || exit
222 esac;;
223 esac
224
225
226 # Generate autoconf and automake snippets.
227
228 (echo '# This file is generated automatically by "bootstrap".' &&
229 echo 'AC_DEFUN([GNULIB_AUTOCONF_SNIPPET],[' &&
230 $GNULIB_SRCDIR/gnulib-tool --extract-autoconf-snippet $gnulib_modules &&
231 echo '])'
232 ) >m4/gnulib.m4 || exit
233
234 (echo '# This file is generated automatically by "bootstrap".' &&
235 $GNULIB_SRCDIR/gnulib-tool --extract-automake-snippet $gnulib_modules
236 ) >lib/gnulib.mk || exit
237
238
239 # Reconfigure, getting other files.
240
241 echo "$0: autoreconf --verbose --install --force ..."
242 autoreconf --verbose --install --force || exit
243
244
245 # We don't need intl, so remove it.
246 # Remove aclocal.m4 too, so that it gets rebuilt.
247 intl_files_to_remove='
248 aclocal.m4
249 intl
250 m4/codeset.m4
251 m4/gettext.m4
252 m4/glibc2.m4
253 m4/glibc21.m4
254 m4/intdiv0.m4
255 m4/intmax.m4
256 m4/inttypes_h.m4
257 m4/inttypes.m4
258 m4/inttypes-pri.m4
259 m4/isc-posix.m4
260 m4/lcmessage.m4
261 m4/lib-ld.m4
262 m4/lib-prefix.m4
263 m4/longdouble.m4
264 m4/longlong.m4
265 m4/po.m4
266 m4/printf-posix.m4
267 m4/signed.m4
268 m4/size_max.m4
269 m4/stdint_h.m4
270 m4/uintmax_t.m4
271 m4/ulonglong.m4
272 m4/wchar_t.m4
273 m4/wint_t.m4
274 m4/xsize.m4
275 '
276 echo $0: rm -fr $intl_files_to_remove ...
277 rm -fr $intl_files_to_remove || exit
278
279 # Put bug-reporting address into po/Makevars.
280 echo "$0: sed '/^MSGID_BUGS_ADDRESS *=/s/=.*/= bug-bison@gnu.org/' po/Makevars.template >po/Makevars ..."
281 sed '/^MSGID_BUGS_ADDRESS *=/s/=.*/= bug-bison@gnu.org/' po/Makevars.template >po/Makevars
282
283 # Likewise for runtime-po/Makevars, except also change a few other parameters.
284 sed '
285 s/^\(DOMAIN\) *=.*/\1 = bison-runtime/
286 s/^\(subdir\) *=.*/\1 = runtime-po/
287 s/^\(XGETTEXT_OPTIONS\) *=.*/\1 = --keyword=YY_/
288 ' <po/Makevars >runtime-po/Makevars
289
290 # Copy identical files from po to runtime-po.
291 (cd po && cp -p Makefile.in.in *-quot *.header *.sed *.sin ../runtime-po)
292
293 # if src/parse-gram.[ch] are out of date, rebuild them.
294 parse_gram_y=`find src/parse-gram.y \
295 '(' -newer src/parse-gram.c -o -newer src/parse-gram.h ')' \
296 -print` || exit
297 case $parse_gram_y in
298 ?*)
299 echo "$0: warning: bootstrapping with old src/parse-gram.[ch] files."
300
301 echo "$0: touch -c src/parse-gram.[ch] ... "
302 touch -c src/parse-gram.[ch] || exit
303
304 echo "$0: ./configure --disable-nls ..."
305 ./configure --disable-nls || exit
306
307 echo "$0: (cd lib && make) ..."
308 (cd lib && make) || exit
309
310 echo "$0: (cd src && make) ..."
311 (cd src && make) || exit
312
313 echo "$0: rm -f src/parse-gram.c src/parse-gram.h ..."
314 rm -f src/parse-gram.c src/parse-gram.h || exit
315
316 echo "$0: (cd src && make parse-gram.c parse-gram.h) ..."
317 (cd src && make parse-gram.c parse-gram.h) || exit
318
319 echo "$0: make distclean ..."
320 make distclean || exit;;
321 esac
322
323 echo "$0: done. Now you can run './configure'."